VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "MainForm"
   ClientHeight    =   3780
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3780
   ScaleWidth      =   6000
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton TestCommand 
      Caption         =   "Test"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4200
      TabIndex        =   0
      Top             =   2640
      Width           =   975
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Type FTC_CHIP_SELECT_PINS
    bADBUS3ChipSelectPinState As Long 'Boolean
    bADBUS4GPIOL1PinState As Long 'Boolean
    bADBUS5GPIOL2PinState As Long 'Boolean
    bADBUS6GPIOL3PinState As Long 'Boolean
    bADBUS7GPIOL4PinState As Long 'Boolean
End Type
    
Private Type FTC_INPUT_OUTPUT_PINS
    bPin1InputOutputState As Long 'Boolean
    bPin1LowHighState As Long 'Boolean
    bPin2InputOutputState As Long 'Boolean
    bPin2LowHighState As Long 'Boolean
    bPin3InputOutputState As Long 'Boolean
    bPin3LowHighState As Long 'Boolean
    bPin4InputOutputState As Long 'Boolean
    bPin4LowHighState As Long 'Boolean
End Type
    
Private Type FTC_LOW_HIGH_PINS
    bPin1LowHighState As Long 'Boolean
    bPin2LowHighState As Long 'Boolean
    bPin3LowHighState As Long 'Boolean
    bPin4LowHighState As Long 'Boolean
End Type
    
Private Type FTC_INIT_CONDITION
    bClockPinState As Long 'Boolean
    bDataOutPinState As Long 'Boolean
    bChipSelectPinState As Long 'Boolean
    ChipSelectPin As Long
End Type
    
Private Type FTC_WAIT_DATA_WRITE
    bWaitDataWriteComplete As Long 'Boolean
    WaitDataWritePin As Long
    bDataWriteCompleteState As Long 'Boolean
    DataWriteTimeoutmSecs As Long
End Type
    
Private Type FTC_HIGHER_OUTPUT_PINS
    bPin1State As Long 'Boolean
    bPin1ActiveState As Long 'Boolean
    bPin2State As Long 'Boolean
    bPin2ActiveState As Long 'Boolean
    bPin3State As Long 'Boolean
    bPin3ActiveState As Long 'Boolean
    bPin4State As Long 'Boolean
    bPin4ActiveState As Long 'Boolean
End Type

Private Declare Function SPI_GetNumDevices Lib "ftcspi" (ByRef NumDevices As Long) As Long
Private Declare Function SPI_GetDeviceNameLocID Lib "ftcspi" (ByVal DeviceNameIndex As Long, ByVal DeviceName As String, ByVal BufferSize As Long, ByRef lpLocationID As Long) As Long
Private Declare Function SPI_OpenEx Lib "ftcspi" (ByVal DeviceName As String, ByVal LocationID As Long, ByRef ftHandle As Long) As Long
Private Declare Function SPI_Open Lib "ftcspi" (ByRef ftHandle As Long) As Long
Private Declare Function SPI_Close Lib "ftcspi" (ByVal ftHandle As Long) As Long
Private Declare Function SPI_InitDevice Lib "ftcspi" (ByVal ftHandle As Long, ByVal ClockDivisor As Long) As Long
Private Declare Function SPI_GetClock Lib "ftcspi" (ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function SPI_SetClock Lib "ftcspi" (ByVal ftHandle As Long, ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function SPI_SetLoopback Lib "ftcspi" (ByVal ftHandle As Long, ByVal bLoopbackState As Boolean) As Long
Private Declare Function SPI_SetGPIOs Lib "ftcspi" (ByVal ftHandle As Long, ByRef pChipSelectsDisableStates As FTC_CHIP_SELECT_PINS, ByRef pHighInputOutputPinsData As FTC_INPUT_OUTPUT_PINS) As Long
Private Declare Function SPI_GetGPIOs Lib "ftcspi" (ByVal ftHandle As Long, ByRef pHighPinsInputData As FTC_LOW_HIGH_PINS) As Long
Private Declare Function SPI_Write Lib "ftcspi" (ByVal ftHandle As Long, ByRef pWriteStartCondition As FTC_INIT_CONDITION, ByVal bClockOutDataBitsMSBFirst As Boolean, ByVal bClockOutDataBitsPosEdge As Boolean, ByVal NumControlBitsToWrite As Long, WriteControlBuffer As Any, ByVal NumControlBytesToWrite As Long, ByVal bWriteDataBits As Boolean, ByVal NumDataBitsToWrite As Long, WriteDataBuffer As Any, ByVal NumDataBytesToWrite As Long, ByRef pWaitDataWriteComplete As FTC_WAIT_DATA_WRITE, ByRef pHighPinsWriteActiveStates As FTC_HIGHER_OUTPUT_PINS) As Long
Private Declare Function SPI_Read Lib "ftcspi" (ByVal ftHandle As Long, ByRef pReadStartCondition As FTC_INIT_CONDITION, ByVal bClockOutDataBitsMSBFirst As Boolean, ByVal bClockOutDataBitsPosEdge As Boolean, ByVal NumControlBitsToWrite As Long, WriteControlBuffer As Any, ByVal NumControlBytesToWrite As Long, ByVal bClockInDataBitsMSBFirst As Boolean, ByVal bClockInDataBitsPosEdge As Boolean, ByVal NumDataBitsToRead As Long, ReadDataBuffer As Any, ByRef lpNumDataBytesReturned As Long, ByRef pHighPinsWriteActiveStates As FTC_HIGHER_OUTPUT_PINS) As Long
Private Declare Function SPI_ClearDeviceCmdSequence Lib "ftcspi" (ByVal ftHandle As Long) As Long
Private Declare Function SPI_AddDeviceWriteCmd Lib "ftcspi" (ByVal ftHandle As Long, ByRef pWriteStartCondition As FTC_INIT_CONDITION, ByVal bClockOutDataBitsMSBFirst As Boolean, ByVal bClockOutDataBitsPosEdge As Boolean, ByVal NumControlBitsToWrite As Long, WriteControlBuffer As Any, ByVal NumControlBytesToWrite As Long, ByVal bWriteDataBits As Boolean, ByVal NumDataBitsToWrite As Long, WriteDataBuffer As Any, ByVal NumDataBytesToWrite As Long, ByRef pHighPinsWriteActiveStates As FTC_HIGHER_OUTPUT_PINS) As Long
Private Declare Function SPI_AddDeviceReadCmd Lib "ftcspi" (ByVal ftHandle As Long, ByRef pReadStartCondition As FTC_INIT_CONDITION, ByVal bClockOutDataBitsMSBFirst As Boolean, ByVal bClockOutDataBitsPosEdge As Boolean, ByVal NumControlBitsToWrite As Long, WriteControlBuffer As Any, ByVal NumControlBytesToWrite As Long, ByVal bClockInDataBitsMSBFirst As Boolean, ByVal bClockInDataBitsPosEdge As Boolean, ByVal NumDataBitsToRead As Long, ByRef pHighPinsWriteActiveStates As FTC_HIGHER_OUTPUT_PINS) As Long
Private Declare Function SPI_ExecuteDeviceCmdSequence Lib "ftcspi" (ByVal ftHandle As Long, ReadCmdSequenceDataBuffer As Any, ByRef lpNumBytesReturned As Long) As Long
Private Declare Function SPI_GetDllVersion Lib "ftcspi" (ByVal DllVersion As String, ByVal BufferSize As Long) As Long
Private Declare Function SPI_GetErrorCodeString Lib "ftcspi" (ByVal Language As String, ByVal StatusCode As Long, ByVal ErrorMessage As String, ByVal BufferSize As Long) As Long

Private Declare Function Sleep Lib "Kernel32" (ByVal Milliseconds As Integer) As Long

Private Const FTC_SUCCESS = 0

Private Const WRITE_CONTROL_BUFFER_SIZE = 256
Private Const WRITE_DATA_BUFFER_SIZE = 65536
Private Const READ_DATA_BUFFER_SIZE = 65536
Private Const READ_CMDS_DATA_BUFFER_SIZE = 131071

Private Const MAX_NUM_DEVICE_NAME_CHARS = 200

Private Const MAX_NUM_DLL_VERSION_CHARS = 10

Private Const MAX_NUM_ERROR_MESSAGE_CHARS = 200

Private Const App_Title = "FT2232C SPI Device Visual Basic V6.0 Test Application"

Private Const MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS = 128

Private Const MAX_FREQ_93LC56_CLOCK_DIVISOR = 3 ' equivalent to 1.5MHz

Private Const ADBUS3ChipSelect = 0

Private Const ADBUS2DataIn = 0

Private Const SPIEWENCmdIndex = 0
Private Const SPIEWDSCmdIndex = 1
Private Const SPIERALCmdIndex = 2

Private Const NUM_93LC56B_CMD_CONTOL_BITS = 11
Private Const NUM_93LC56B_CMD_CONTOL_BYTES = 2

Private Const NUM_93LC56B_CMD_DATA_BITS = 16
Private Const NUM_93LC56B_CMD_DATA_BYTES = 2

Private ftHandle As Long

Private Sub Form_Load()

    MainForm.Caption = App_Title
    
    ftHandle = 0
End Sub
Private Sub Form_Unload(Cancel As Integer)
        Dim ftStatus As Long
        
        ftStatus = DS_SUCCESS

        If (ftHandle <> 0) Then
            ftStatus = SPI_Close(ftHandle)
        End If
End Sub
Private Function ConvertDLLStringToVBString(ByRef DLLString As String) As String
    Dim VBString As String
    Dim DllCharCntr As Long
    Dim VBCharCntr As Long
    Dim DLLStrCharArray() As Byte
    Dim VBStrCharArray() As Byte
        
    DllCharCntr = 0

    DLLStrCharArray = StrConv(DLLString, vbFromUnicode)   ' Convert string.

    While (DLLStrCharArray(DllCharCntr) <> 0)
        DllCharCntr = DllCharCntr + 1
    Wend
        
    ReDim VBStrCharArray(0 To (DllCharCntr - 1)) As Byte
    For VBCharCntr = 0 To (DllCharCntr - 1)
        VBStrCharArray(VBCharCntr) = DLLStrCharArray(VBCharCntr)
    Next

    ConvertDLLStringToVBString = StrConv(VBStrCharArray, vbUnicode)
End Function

Private Function SPI_EWEN_EWDS_ERAL_93LC56B_Device(ByVal ftHandle As Long, ByRef pWriteStartCondition As FTC_INIT_CONDITION, ByVal SPICmdIndex As Integer) As Integer
    Dim ftStatus As Integer
    Dim ControlByte1 As Integer
    Dim ControlByte2 As Integer
    Dim WriteControlBuffer((WRITE_CONTROL_BUFFER_SIZE - 1)) As Byte
    Dim WriteDataBuffer((WRITE_DATA_BUFFER_SIZE - 1)) As Byte
    Dim WaitDataWriteComplete As FTC_WAIT_DATA_WRITE
    Dim HighPinsWriteActiveStates As FTC_HIGHER_OUTPUT_PINS
        
    ftStatus = FTC_SUCCESS
    ControlByte1 = 0
    ControlByte2 = 0

    Select Case SPICmdIndex
        Case SPIEWENCmdIndex
            ControlByte1 = &H9F ' set up write enable command
        Case SPIEWDSCmdIndex
            ControlByte1 = &H87 ' set up write disable command
        Case SPIERALCmdIndex
            ControlByte1 = &H97 ' set up erase all command
    End Select

    ControlByte2 = &HFF

    WriteControlBuffer(0) = ControlByte1
    WriteControlBuffer(1) = ControlByte2

    WaitDataWriteComplete.bWaitDataWriteComplete = False

    ftStatus = SPI_Write(ftHandle, pWriteStartCondition, True, False, NUM_93LC56B_CMD_CONTOL_BITS, WriteControlBuffer(0), NUM_93LC56B_CMD_CONTOL_BYTES, False, 0, WriteDataBuffer(0), 0, WaitDataWriteComplete, HighPinsWriteActiveStates)

    SPI_EWEN_EWDS_ERAL_93LC56B_Device = ftStatus
End Function

Private Sub TestCommand_Click()
    Dim ftStatus As Integer
    Dim NumDevices As Long
    Dim DeviceName As String
    Dim DN As String
    Dim LocationID As Long
    Dim bPerformCommandSequence As Boolean
    Dim ClockFrequencyHz As Long
    Dim bLoopbackState As Boolean
    Dim DataWriteType As Integer
    Dim ControlLocAddress1 As Integer
    Dim ControlLocAddress2 As Integer
    Dim WriteDataWordAddress As Integer
    Dim ChipSelectsDisableStates As FTC_CHIP_SELECT_PINS
    Dim HighInputOutputPins As FTC_INPUT_OUTPUT_PINS
    Dim WriteStartCondition As FTC_INIT_CONDITION
    Dim WriteControlBuffer((WRITE_CONTROL_BUFFER_SIZE - 1)) As Byte
    Dim DataWord As Integer
    Dim bWriteWait As Boolean
    Dim NumDataBitsToWrite As Long
    Dim WriteDataBuffer((WRITE_DATA_BUFFER_SIZE - 1)) As Byte
    Dim NumDataBytesToWrite As Long
    Dim WriteDataBufferIndex As Integer
    Dim WaitDataWriteComplete As FTC_WAIT_DATA_WRITE
    Dim HighPinsWriteActiveStates As FTC_HIGHER_OUTPUT_PINS
    Dim ReadStartCondition As FTC_INIT_CONDITION
    Dim ReadDataBuffer((WRITE_DATA_BUFFER_SIZE - 1)) As Byte
    Dim NumDataBytesReturned As Long
    Dim ReadCmdSequenceDataBuffer((READ_CMDS_DATA_BUFFER_SIZE - 1)) As Byte
    Dim ReadWordData((MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS - 1)) As Long
    Dim ReadWordValue As Long
    Dim ReadDataIndex As Integer
    Dim ReadDataWordAddress As Integer
    Dim DataReadType As Integer
    Dim NumDataBytesToRead As Long
    Dim MsgBoxKeyPressed As Integer
    Dim DataWordWritten As Long
    Dim CharCntr As Integer
    Dim iLoopCntr As Integer
    Dim Msg, Style, Title, Response As String
    Dim ErrorMessage As String
    'Dim DllVersion As String
    
    ftStatus = FTC_SUCCESS
    NumDevices = 0
    DeviceName = String$(MAX_NUM_DEVICE_NAME_CHARS, Chr(0))
    LocationID = 0
    bPerformCommandSequence = True
    ClockFrequencyHz = 0
    bLoopbackState = False
    DataWord = 0
    bWriteWait = True
    NumDataBitsToWrite = 0
    NumDataBytesToWrite = 0
    WriteDataBufferIndex = 0
    ReadDataIndex = 0
    ReadDataWordAddress = 0
    DataReadType = 0
    NumDataBytesToRead = 0
    MsgBoxKeyPressed = 0
    DataWordWritten = 0
    CharCntr = 0
    iLoopCntr = 0

    ErrorMessage = String$(MAX_NUM_ERROR_MESSAGE_CHARS, ChrW(0))
    
    'DllVersion = String$(MAX_NUM_DLL_VERSION_CHARS, Chr(0))
    'ftStatus = SPI_GetDllVersion(DllVersion, MAX_NUM_DLL_VERSION_CHARS)
    'MsgBox(DllVersion)

    ftStatus = SPI_GetNumDevices(NumDevices)

    If ((ftStatus = FTC_SUCCESS) And (NumDevices > 0)) Then
        If (NumDevices = 1) Then
            ftStatus = SPI_GetDeviceNameLocID(0, DeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID)

            If (ftStatus = FTC_SUCCESS) Then
                DN = ConvertDLLStringToVBString(DeviceName)
                ftStatus = SPI_OpenEx(DN, LocationID, ftHandle)
            End If

            'ftStatus = SPI_Open(ftHandle)
        Else
            If (NumDevices = 2) Then
                ftStatus = SPI_GetDeviceNameLocID(1, DeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID)

                If (ftStatus = FTC_SUCCESS) Then
                    DN = ConvertDLLStringToVBString(DeviceName)
                    ftStatus = SPI_OpenEx(DN, LocationID, ftHandle)
                End If

                'ftStatus = SPI_Open(ftHandle)
            End If
        End If

        If ((ftHandle <> 0) And (ftStatus = FTC_SUCCESS)) Then
            ftStatus = SPI_InitDevice(ftHandle, MAX_FREQ_93LC56_CLOCK_DIVISOR)

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = SPI_GetClock(MAX_FREQ_93LC56_CLOCK_DIVISOR, ClockFrequencyHz)
            End If

            'If (ftStatus = FTC_SUCCESS) Then
            'ftStatus = SPI_SetLoopback(ftHandle, False)
            'End If

            If (bPerformCommandSequence = True) Then
                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = SPI_ClearDeviceCmdSequence(ftHandle)
                End If
            End If

            If (ftStatus = FTC_SUCCESS) Then
                ' Must set the chip select disable states for all the SPI devices connected to the FT2232C dual device
                ChipSelectsDisableStates.bADBUS3ChipSelectPinState = False
                ChipSelectsDisableStates.bADBUS4GPIOL1PinState = False
                ChipSelectsDisableStates.bADBUS5GPIOL2PinState = False
                ChipSelectsDisableStates.bADBUS6GPIOL3PinState = False
                ChipSelectsDisableStates.bADBUS7GPIOL4PinState = False

                HighInputOutputPins.bPin1InputOutputState = True
                HighInputOutputPins.bPin1LowHighState = False
                HighInputOutputPins.bPin2InputOutputState = True
                HighInputOutputPins.bPin2LowHighState = False
                HighInputOutputPins.bPin3InputOutputState = True
                HighInputOutputPins.bPin3LowHighState = False
                HighInputOutputPins.bPin4InputOutputState = True
                HighInputOutputPins.bPin4LowHighState = False

                ftStatus = SPI_SetGPIOs(ftHandle, ChipSelectsDisableStates, HighInputOutputPins)

                If (ftStatus = FTC_SUCCESS) Then
                    WriteStartCondition.bClockPinState = False
                    WriteStartCondition.bDataOutPinState = False
                    WriteStartCondition.bChipSelectPinState = False
                    WriteStartCondition.ChipSelectPin = ADBUS3ChipSelect
                
                    ' enable writing
                    'ftStatus = SPI_EWEN_EWDS_ERAL_93LC56B_Device(ftHandle, WriteStartCondition, SPIEWENCmdIndex)

                    If (ftStatus = FTC_SUCCESS) Then
                        ' erase all
                        'ftStatus = SPI_EWEN_EWDS_ERAL_93LC56B_Device(ftHandle, WriteStartCondition, SPIERALCmdIndex)

                        If (ftStatus = FTC_SUCCESS) Then
                            ' disable writing
                            'ftStatus = SPI_EWEN_EWDS_ERAL_93LC56B_Device(ftHandle, WriteStartCondition, SPIEWDSCmdIndex)
                        End If
                    End If
                End If
            End If

            Sleep (2000)
            
            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = SPI_InitDevice(ftHandle, MAX_FREQ_93LC56_CLOCK_DIVISOR)
            End If

            If (ftStatus = FTC_SUCCESS) Then
                WaitDataWriteComplete.bWaitDataWriteComplete = True
                WaitDataWriteComplete.WaitDataWritePin = ADBUS2DataIn
                WaitDataWriteComplete.bDataWriteCompleteState = True
                WaitDataWriteComplete.DataWriteTimeoutmSecs = 5000

                HighPinsWriteActiveStates.bPin1ActiveState = False
                HighPinsWriteActiveStates.bPin1State = False
                HighPinsWriteActiveStates.bPin2ActiveState = False
                HighPinsWriteActiveStates.bPin2State = False
                HighPinsWriteActiveStates.bPin3ActiveState = False
                HighPinsWriteActiveStates.bPin3State = False
                HighPinsWriteActiveStates.bPin4ActiveState = False
                HighPinsWriteActiveStates.bPin4State = False

                DataWord = 0
                'DataWord = 30583 '\x7777';

                NumDataBitsToWrite = NUM_93LC56B_CMD_DATA_BITS
                NumDataBytesToWrite = NUM_93LC56B_CMD_DATA_BYTES

                WriteDataWordAddress = 0

                Do
                    ' set up write command and address
                    ControlLocAddress1 = &HA0
                    ' shift down/right by 3 bits
                    ControlLocAddress1 = (ControlLocAddress1 Or ((WriteDataWordAddress \ 8) And &HF))

                    ' shift left 5 bits ie make bottom 3 bits the 3 MSB's
                    ControlLocAddress2 = ((WriteDataWordAddress And &H7) * 32)

                    WriteControlBuffer(0) = (ControlLocAddress1 And &HFF)
                    WriteControlBuffer(1) = (ControlLocAddress2 And &HFF)

                    ' write data
                    WriteDataBuffer(0) = (DataWord And &HFF)
                    ' shift down by 8 bits
                    WriteDataBuffer(1) = ((DataWord \ 256) And &HFF)

                    ftStatus = SPI_Write(ftHandle, WriteStartCondition, True, False, NUM_93LC56B_CMD_CONTOL_BITS, WriteControlBuffer(0), NUM_93LC56B_CMD_CONTOL_BYTES, True, NumDataBitsToWrite, WriteDataBuffer(0), NumDataBytesToWrite, WaitDataWriteComplete, HighPinsWriteActiveStates)

                    If (DataWord <> 30583) Then
                        DataWord = DataWord + 1
                    End If

                    WriteDataWordAddress = WriteDataWordAddress + 1
                Loop While ((WriteDataWordAddress < MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS) And (ftStatus = FTC_SUCCESS))

                Sleep (200)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = SPI_InitDevice(ftHandle, MAX_FREQ_93LC56_CLOCK_DIVISOR)

                    If (ftStatus = FTC_SUCCESS) Then
                        Do
                            Sleep (200)

                            ReadStartCondition.bClockPinState = False
                            ReadStartCondition.bDataOutPinState = False
                            ReadStartCondition.bChipSelectPinState = False
                            ReadStartCondition.ChipSelectPin = ADBUS3ChipSelect

                            For ReadDataIndex = 0 To (MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS - 1)
                                ReadWordData(ReadDataIndex) = 0
                            Next

                            ReadDataWordAddress = 0

                            Do
                                ' set up read command and address
                                ControlLocAddress1 = 192 '\xC0';
                                ' shift down/right by 3 bits
                                ControlLocAddress1 = (ControlLocAddress1 Or ((ReadDataWordAddress \ 8) And &HFF))

                                ' shift left 5 bits ie make bottom 3 bits the 3 MSB's
                                ControlLocAddress2 = ((ReadDataWordAddress And &H7) * 32)

                                WriteControlBuffer(0) = (ControlLocAddress1 And &HFF)
                                WriteControlBuffer(1) = (ControlLocAddress2 And &HFF)

                                If (bPerformCommandSequence = False) Then
                                    ftStatus = SPI_Read(ftHandle, ReadStartCondition, True, False, NUM_93LC56B_CMD_CONTOL_BITS, WriteControlBuffer(0), NUM_93LC56B_CMD_CONTOL_BYTES, True, False, NUM_93LC56B_CMD_DATA_BITS, ReadDataBuffer(0), NumDataBytesReturned, HighPinsWriteActiveStates)

                                    If (ftStatus = FTC_SUCCESS) Then
                                        'ReadWordValue = ((ReadDataBuffer(1) * 256) Or ReadDataBuffer(0))
                                        ReadWordValue = ReadDataBuffer(1)
                                        ReadWordValue = (ReadWordValue * 256)
                                        ReadWordValue = (ReadWordValue Or ReadDataBuffer(0))

                                        ReadWordData(ReadDataWordAddress) = ReadWordValue
                                    End If
                                Else
                                    ftStatus = SPI_AddDeviceReadCmd(ftHandle, ReadStartCondition, True, False, NUM_93LC56B_CMD_CONTOL_BITS, WriteControlBuffer(0), NUM_93LC56B_CMD_CONTOL_BYTES, True, False, NUM_93LC56B_CMD_DATA_BITS, HighPinsWriteActiveStates)
                                End If

                                ReadDataWordAddress = ReadDataWordAddress + 1
                            Loop While ((ReadDataWordAddress < MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS) And (ftStatus = FTC_SUCCESS))

                            If (ftStatus = FTC_SUCCESS) Then
                                ReadDataIndex = 0

                                Response = vbOK
                                Style = vbOKCancel + vbCritical   ' Define buttons.
                                Title = "SPI Read Error Message"   ' Define title.
                                
                                If (bPerformCommandSequence = True) Then
                                    ftStatus = SPI_ExecuteDeviceCmdSequence(ftHandle, ReadCmdSequenceDataBuffer(0), NumDataBytesReturned)

                                    If (ftStatus = FTC_SUCCESS) Then
                                        If (NumDataBytesReturned > 0) Then
                                            ReadDataWordAddress = 0

                                            ReadDataIndex = 0

                                            Do
                                                'ReadWordValue = ((ReadCmdSequenceDataBuffer(ReadDataIndex + 1) * 256) Or ReadCmdSequenceDataBuffer(ReadDataIndex))
                                                ReadWordValue = ReadCmdSequenceDataBuffer(ReadDataIndex + 1)
                                                ReadWordValue = (ReadWordValue * 256)
                                                ReadWordValue = (ReadWordValue Or ReadCmdSequenceDataBuffer(ReadDataIndex))

                                                ReadWordData(ReadDataWordAddress) = ReadWordValue

                                                ReadDataIndex = (ReadDataIndex + 2)

                                                ReadDataWordAddress = ReadDataWordAddress + 1
                                            Loop While (ReadDataIndex < NumDataBytesReturned)
                                        Else
                                            Response = MsgBox("No data returned.", Style, "SPI Execute Command Sequence")
                                        End If
                                    End If
                                End If
                                
                                If ((ftStatus = FTC_SUCCESS) And (Response = vbOK)) Then
                                    ReadDataIndex = 0
                                
                                    Do
                                        If (DataWord = 30583) Then
                                            DataWordWritten = DataWord
                                        Else
                                            DataWordWritten = ReadDataIndex
                                        End If

                                        If (((ReadWordData(ReadDataIndex) <> DataWordWritten) And (DataWord <> 0)) Or ((ReadWordData(ReadDataIndex) <> DataWordWritten) And (DataWord = 0))) Then
                                            For CharCntr = 0 To (100 - 1)
                                                WriteDataBuffer(CharCntr) = 0
                                            Next

                                            Msg = "SPI 93LC56 Read/Write mismatch, Address = " + Format(ReadDataIndex) + ", Write Value = " + Format(DataWordWritten) + ", Read Value = " + Format(ReadWordData(ReadDataIndex))
                                         
                                            Response = MsgBox(Msg, Style, Title)
                                        End If

                                        ReadDataIndex = ReadDataIndex + 1
                                    Loop While ((ReadDataIndex < MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS) And (Response = vbOK))
                                End If
                            End If

                            iLoopCntr = iLoopCntr + 1
                        Loop While ((iLoopCntr < 10) And (ftStatus = FTC_SUCCESS) And (Response = vbOK))

                        SPI_Close (ftHandle)
                        ftHandle = 0
                    End If
                End If
            End If
        End If
    End If

    If (ftStatus <> FTC_SUCCESS) Then
        ftStatus = SPI_GetErrorCodeString("EN", ftStatus, ErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)

        MsgBox (ErrorMessage)
    End If
 End Sub
